﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;

using System.Linq;

using Vintagestory.API.Common.Entities;

namespace Automap
{
	/// <summary>
	/// Entities of interest.
	/// </summary>
	/// <remarks>Tracked by ID - these never leave.</remarks>
	public class EntitiesOfInterest
	{
		private Dictionary<long, PointOfInterest> entitySet = new Dictionary<long, PointOfInterest>(50);


		internal void Upsert(Entity something, string message = @"")
		{
			if (entitySet.ContainsKey(something.EntityId))
			{
				var movingPOI = entitySet[something.EntityId];
				movingPOI.Location = something.Pos.AsBlockPos.Copy();
				movingPOI.Timestamp = DateTimeOffset.UtcNow;
			}
			else
			{
				PointOfInterest newPOI = new PointOfInterest();
				newPOI.EntityId = something.EntityId;
				newPOI.Location = something.Pos.AsBlockPos.Copy();
				newPOI.Timestamp = DateTimeOffset.UtcNow;
				newPOI.Notes = message;
				entitySet.Add(something.EntityId, newPOI);
			}

		}


		public List<PointOfInterest> PointsList
		{
			get {
				return entitySet.Values.ToList();
			}
		}

	}
}

