﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Drawing;

using Vintagestory.API.Client;
using Vintagestory.API.Common;
using Vintagestory.API.Common.Entities;
using Vintagestory.API.MathTools;

namespace Automap
{
	public delegate void EntityDesignatonAction(ICoreClientAPI clientAPI, EntitiesOfInterest poi, BlockPos posn, Entity entity);

	/// <summary>
	/// Point of Interest Rule Designator
	/// </summary>
	public class EntityDesignator
	{
		public Color OverwriteColor;
		public EntityDesignatonAction SpecialAction;
		public AssetLocation Pattern;
		public EnumEntityState? StateCheck;//Needed?
		public bool Enabled { get; set; }

		private EntityDesignator()
		{
			throw new NotSupportedException();
		}

		public EntityDesignator(AssetLocation pattern, Color overwriteColor, EnumEntityState? state)
		{
			this.Pattern = pattern;
			this.OverwriteColor = overwriteColor;
			this.StateCheck = state;
			this.Enabled = true;
		}

		public EntityDesignator(AssetLocation pattern, Color overwriteColor, EnumEntityState? state, EntityDesignatonAction specialAct)
		{
			this.Pattern = pattern;
			this.OverwriteColor = overwriteColor;
			this.StateCheck = state;
			this.SpecialAction = specialAct;
			this.Enabled = true;
		}

		public override string ToString()
		{
			return Pattern.ToShortString() + "|" + OverwriteColor.Name + "|" + StateCheck ?? "";
		}
	}
}

